//+------------------------------------------------------------------+
//|                                                    Concord99.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_minimum -1.0
#property indicator_maximum  1.0
#property indicator_level1   0.0
extern int Per     = 100;
int        History = 100000;
double     MA_1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    SetIndexBuffer (0, MA_1);
    SetIndexStyle (0, DRAW_HISTOGRAM, STYLE_SOLID, 2, Blue);
    SetIndexEmptyValue (0, 0.);
    IndicatorDigits (0);
    if (History > Bars) History = Bars;
    return;
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    int i, pos, qb, Counted_bars = IndicatorCounted();
    double My_24EMA, My_24EMA1;
    i = Bars - Counted_bars;
    if (i > History - 1) i = History - 1;
    while (i >= 0)
    { 
        pos = i + 1;
        MA_1[pos] = 0.; 
        My_24EMA = iMA (NULL, 0, Per, 0, MODE_EMA, PRICE_CLOSE, pos);    
        My_24EMA1 = iMA (NULL, 0, Per, 0, MODE_EMA, PRICE_CLOSE, pos + 1);
        if (Close[pos] > My_24EMA) if (Close[pos+1] < My_24EMA1) 
        {MA_1[pos] = 1.;}
        if (Close[pos] < My_24EMA) if (Close[pos+1] > My_24EMA1)
        {MA_1[pos] = -1.;}
        if (MA_1[pos] == 0.) 
        {
            bool cond = true;
            for (qb = pos + 1; qb <= pos + 5; qb++)
            {
                if (qb == pos + 1) {if (MA_1[qb] == 0.) {cond = false; break;}}
                else if (qb < pos + 5) {if (MA_1[qb] != MA_1[qb+1]) break;}
                else if (qb == pos + 5) {if (MA_1[qb] == MA_1[qb+1]) cond = false;}
            }
            if (cond) MA_1[pos] = MA_1[pos+1];
        }
        i--;
    }
    return (0);
}
//+------------------------------------------------------------------+